import React from 'react';
import PropTypes from 'prop-types';
import { WithAsProps } from '../@types/common';
export interface StackItemProps extends WithAsProps {
    alignSelf?: 'flex-start' | 'flex-end' | 'center' | 'baseline' | 'stretch';
    flex?: React.CSSProperties['flex'];
    grow?: React.CSSProperties['flexGrow'];
    shrink?: React.CSSProperties['flexShrink'];
    basis?: React.CSSProperties['flexBasis'];
    order?: React.CSSProperties['order'];
}
declare function StackItem(props: StackItemProps): JSX.Element;
declare namespace StackItem {
    var displayName: string;
    var propTypes: {
        className: PropTypes.Requireable<string>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        alignSelf: PropTypes.Requireable<string>;
        flex: PropTypes.Requireable<string | number>;
        grow: PropTypes.Requireable<number>;
        shrink: PropTypes.Requireable<number>;
        order: PropTypes.Requireable<number>;
        basis: PropTypes.Requireable<string>;
    };
}
export default StackItem;
